<?php

namespace STM\Team;

use \Exception;
use STM\Competition\CompetitionSelection;
use STM\Match\Match;
use STM\Match\MatchSelection;
use STM\StmFactory;

/**
 * Test class for Team.
 * Generated by PHPUnit on 2012-02-14 at 16:07:59.
 * @group team
 */
class TeamTest extends \PHPUnit_Framework_TestCase {

    /** @var array(Team) */
    protected $all_teams;

    protected function setUp() {
        TeamValidator::init();
        $this->all_teams = StmFactory::find()->Team->findAll();
    }

    public function testFind_all() {
        parent::assertTrue(is_array($this->all_teams));
        foreach ($this->all_teams as $team) {            
            parent::assertInstanceOf('\STM\Team\Team', $team);
        }
    }

    public function testfindById() {
        foreach ($this->all_teams as $team) {            
            parent::assertInstanceOf('\STM\Team\Team', StmFactory::find()->Team->findById($team->getId()));
        }
        // argument must be numeric
        parent::assertFalse(StmFactory::find()->Team->findById('makovp'));
        parent::assertFalse(StmFactory::find()->Team->findById(null));
        parent::assertFalse(StmFactory::find()->Team->findById(new Exception()));
    }

    public function testFind_teams_from_club() {
        foreach (StmFactory::find()->Club->findAll() as $club) {            
            parent::assertTrue(is_array(StmFactory::find()->Team->findByClub($club)));
        }
    }

    public function testFind_teams_from_competition() {
        $cs = new CompetitionSelection();
        $cs->setLimit(5);
        foreach (StmFactory::find()->Competition->find($cs) as $competition) {            
            parent::assertTrue(is_array(StmFactory::find()->Team->findByCompetition($competition)));
        }
    }

    public function testCreate() {
        parent::markTestSkipped('test in TeamValidatorTest');
    }

    public function testExists_team() {
        foreach ($this->all_teams as $team) {            
            $name = $team->__toString();   
            // case-INsensitive
            parent::assertTrue(Team::exists($name));            
            parent::assertTrue(Team::exists(mb_strtolower($name, 'UTF-8')));
            parent::assertTrue(Team::exists(mb_strtoupper($name, 'UTF-8')));
            parent::assertFalse(Team::exists('_*A*_' . $name));
            // argumetn must be string
            parent::assertFalse(Team::exists($team));
            parent::assertFalse(Team::exists(null));
        }
    }


    public function testUpdate() {
        parent::markTestSkipped('test in TeamValidatorTest');
    }

    public function testDelete() {
        parent::markTestSkipped('in testCan_be_deleted, otherwise only DB fail');
    }

    public function testCan_be_deleted() {
        foreach ($this->all_teams as $team) {            
            $members = StmFactory::find()->TeamMember->findByTeam($team);
            $cs = new CompetitionSelection();
            $cs->setTeam($team);
            $competitions = StmFactory::find()->Competition->find($cs);           
            $ms = array(
                'matchType' => \STM\Match\MatchSelection::ALL_MATCHES,
                'loadScores' => true,
                'loadPeriods' => true,
                'teams' => array($team),
            );
            $matches = StmFactory::find()->Match->find($ms);
            $canBeDeleted = empty($members) && empty($competitions) && empty($matches);
            parent::assertTrue($team->canBeDeleted() == $canBeDeleted);
        }
    }

    public function testGet_id() {
        $this->assert_get_to_function('is_int', 'getId');
    }

    public function testGet_id_club() {
        $this->assert_get_to_function('is_int', 'getIdClub');
    }
    
    public function testGet_club_name() {
        $this->assert_get_to_function('is_string', 'getNameClub');
    }    

    public function testTo_array() {
        $this->assert_get_to_function('is_array', 'toArray');
    }

    public function test__toString() {
        $this->assert_get_to_function('is_string', '__toString');
    }
    
    private function assert_get_to_function($function, $method_name) {
        foreach ($this->all_teams as $team) {
            parent::assertTrue($function($team->$method_name()));
        }
    }

}

?>